%%-------------------------------------------------------------------------
% Main code for chapter 5: univariate time-sries
%--------------------------------------------------------------------------

% -------------- Room saving ----------------------------------------------

close all; clear all; clc; pause(0.01), randn('seed',sum(clock)), rand('seed',sum(clock)), warning off
TSTART = tic;
% -------------- Load folders ---------------------------------------------

addpath([pwd '\Input\']);
addpath([pwd '\Utilities\']);
addpath([pwd '\Output\']);

% -------------- Import data  and transform -------------------------------
[data,textdata,raw] = xlsread('STOCKINT2013.xls','Monthly');
%[filename,pathname]=uigetfile('*.xls');
%[data,textdata,raw] = xlsread(filename,'Monthly');

%Convert dates into a serial number
date=datenum(textdata(4:end,1),'dd/mm/yyyy');

run ch5_datatran

%--------------------------------------------------------------------------
% SECTION 1: Simulated and Actual Time-Series
%--------------------------------------------------------------------------
run ch5_section1 
%--------------------------------------------------------------------------
% SECTION 2: Persistence: A Monte Carlo Experiment
%--------------------------------------------------------------------------
run ch5_section2
%--------------------------------------------------------------------------
% SECTION 3: Putting ARMA models at Work
%--------------------------------------------------------------------------
run ch5_section3
%--------------------------------------------------------------------------
% SECTION 4: Stochastic and Deterministic Trends,Beveridge-Nelson Decomposition
%--------------------------------------------------------------------------
run ch5_section4
%--------------------------------------------------------------------------
% SECTION 5: Portfolio Allocation with univariate TS models 
%--------------------------------------------------------------------------
run ch5_section5



tElapsed = toc(TSTART);
display(['The time needed to run the code is: ',num2str(tElapsed/60),' minutes']);         










