
% BUILDING RETURNS 
% --------------  German risk-free please note dating ---------
GER.RiskFree  = log(1+(lag(data(:,2))/(100*12)));
GER.RiskFree(1,1)=NaN;
%  German Long term bond YTM and period holding returns
GER.LTBond.Yield   = (log(1+(data(:,1))/(100*12)));
GER.LTBond.Duration = 12*((1-(1+(data(:,1)/(100))).^(-10)))./(1-(1+(data(:,1)/(100))).^(-1));
GER.LTBond.Ret   = (lag(GER.LTBond.Duration,1,NaN).*lag(GER.LTBond.Yield,1,NaN)-(lag(GER.LTBond.Duration,1,NaN)-1).*GER.LTBond.Yield);
GER.LTBond.ExRet     = GER.LTBond.Ret - GER.RiskFree;

% -------------- German Stocks Monthly excess returns  ------------------
GER.Stock.DY     = data(:,4)/(100*12);           % Monthly dividend yield
GER.Stock.dy     = log(GER.Stock.DY);            % Monthly log dividend yield
GER.Stock.Index  = data(:,3);                    % Monthly stock index
GER.Stock.lp     = log(GER.Stock.Index);
GER.Stock.Ret    = log(GER.Stock.Index./lag(GER.Stock.Index,1,NaN)+GER.Stock.DY);
GER.Stock.ExRet  = GER.Stock.Ret - GER.RiskFree;
% -------------- Forex Exchanges ------------------------------------------

FX.EUvsUS=data(:,10);
FX.USvsUK=data(:,9);
FX.EUvsUK=FX.EUvsUS.*FX.USvsUK;
FX.r_EUvsUS  = log(FX.EUvsUS./lag(FX.EUvsUS,1,NaN));
FX.r_USvsUK  = log(FX.USvsUK./lag(FX.USvsUK,1,NaN));
FX.r_EUvsUK  = FX.r_EUvsUS + FX.r_USvsUK;

% -------------- US Stocks Monthly Excess Returns -------------------------

US.Stock.DY      = data(:,6)/(100*12);                                                          % US dividend yield
US.Stock.dy      = log(data(:,6));                                                              % US log dividend yield
US.Stock.Index   = data(:,5);                                                                   % US stock index
US.Stock.lp     = log(US.Stock.Index);
US.Stock.Ret     = log(US.Stock.Index./lag(US.Stock.Index,1,NaN)+US.Stock.DY);                        % Returns in dollar amounts
US.Stock.Reteu     = US.Stock.Ret + FX.r_EUvsUS;                                                    % Returns in euros (german perspective) 
US.Stock.ExRet   = US.Stock.Reteu - GER.RiskFree;                                                 % Excess returns in euros


% ------------- UK Stocks Monthly Excess Returns --------------------------

UK.Stock.DY      = data(:,8)/(100*12);                                                         % UK dividend yield
UK.Stock.dy      = log(data(:,8));                                                             % UK log dividend yield
UK.Stock.Index   = data(:,7);                                                                  % UK stock index
UK.Stock.lp     = log(UK.Stock.Index);
UK.Stock.Ret     = log(UK.Stock.Index./lag(UK.Stock.Index,1,NaN)+UK.Stock.DY);                  % Returns in dollar amounts
UK.Stock.Reteu     = UK.Stock.Ret + FX.r_EUvsUK;                                                    % Returns in euros (german perspective) 
UK.Stock.ExRet   = UK.Stock.Reteu - GER.RiskFree;                                                 % Excess returns in euros


%--------------------------------------------------------------------------
%-------- Creates returns at different frequencies ------------------------
%--------------------------------------------------------------------------
% Calculate log returns
%country=strvcat('US','UK', 'GER'));
t = [1:size(US.Stock.Index)];
US.Stock.Reteu1Y   =NaN(size(US.Stock.Index));
for i=12:size(t,2)
US.Stock.Reteu1Y(i,:) = sum(US.Stock.Reteu(t(i)-11:t(i)));
end
US.Stock.Reteu3Y   =NaN(size(US.Stock.Index));
for i=36:size(t,2)
US.Stock.Reteu3Y(i,:) = sum(US.Stock.Reteu(t(i)-35:t(i)));
end
US.Stock.Reteu3Ya(i,:)=US.Stock.Reteu3Y(i,:)/3;

% exact returns
US.Stock.Reteu1Ye   =NaN(size(US.Stock.Index));
for i=12:size(t,2)
US.Stock.Reteu1Ye(i,:) = prod(1+US.Stock.Reteu(t(i)-11:t(i)))-1;
end
US.Stock.Reteu3Ye   =NaN(size(US.Stock.Index));
for i=36:size(t,2)
US.Stock.Reteu3Ye(i,:) = prod(1+US.Stock.Reteu(t(i)-35:t(i)))-1;
end
US.Stock.Reteu3Yea=((1+US.Stock.Reteu3Ye).^(1/3))-1;

UK.Stock.Reteu1Y   =NaN(size(UK.Stock.Index));
for i=12:size(t,2)
UK.Stock.Reteu1Y(i,:) = sum(UK.Stock.Reteu(t(i)-11:t(i)));
end
UK.Stock.Reteu3Y   =NaN(size(UK.Stock.Index));
for i=36:size(t,2)
UK.Stock.Reteu3Y(i,:) = sum(UK.Stock.Reteu(t(i)-35:t(i)));
end
UK.Stock.Reteu3Ya(i,:)=UK.Stock.Reteu3Y(i,:)/3;

% exact returns
UK.Stock.Reteu1Ye   =NaN(size(UK.Stock.Index));
for i=12:size(t,2)
UK.Stock.Reteu1Ye(i,:) = prod(1+UK.Stock.Reteu(t(i)-11:t(i)))-1;
end
UK.Stock.Reteu3Ye   =NaN(size(UK.Stock.Index));
for i=36:size(t,2)
UK.Stock.Reteu3Ye(i,:) = prod(1+UK.Stock.Reteu(t(i)-35:t(i)))-1;
end
UK.Stock.Reteu3Yea=((1+UK.Stock.Reteu3Ye).^(1/3))-1;

GER.Stock.Ret1Y   =NaN(size(GER.Stock.Index));
for i=12:size(t,2)
GER.Stock.Ret1Y(i,:) = sum(GER.Stock.Ret(t(i)-11:t(i)));
end
GER.Stock.Ret3Y   =NaN(size(GER.Stock.Index));
for i=36:size(t,2)
GER.Stock.Ret3Y(i,:) = sum(GER.Stock.Ret(t(i)-35:t(i)));
end
GER.Stock.Ret3Ya=GER.Stock.Ret3Y/3;
GER.RF.Ret3Y   =NaN(size(GER.Stock.Index));
for i=36:size(t,2)
GER.RF.Ret3Y(i,:) = sum(GER.RiskFree(t(i)-35:t(i)));
end
GER.LTB.Ret3Y   =NaN(size(GER.Stock.Index));
for i=36:size(t,2)
GER.LTB.Ret3Y(i,:) = sum(GER.LTBond.Ret(t(i)-35:t(i)));
end


% exact returns
GER.Stock.Ret1Ye   =NaN(size(GER.Stock.Index));
for i=12:size(t,2)
GER.Stock.Ret1Ye(i,:) = prod(1+GER.Stock.Ret(t(i)-11:t(i)))-1;
end
GER.Stock.Ret3Ye   =NaN(size(GER.Stock.Index));
for i=36:size(t,2)
GER.Stock.Ret3Ye(i,:) = prod(1+GER.Stock.Ret(t(i)-35:t(i)))-1;
end
%excess returns 3Y horz
GER.LTB.ExRet3Y=GER.LTB.Ret3Y-GER.RF.Ret3Y;
GER.Stock.ExRet3Y=GER.Stock.Ret3Y-GER.RF.Ret3Y;
UK.Stock.ExRet3Y=UK.Stock.Reteu3Y-GER.RF.Ret3Y;
US.Stock.ExRet3Y=US.Stock.Reteu3Y-GER.RF.Ret3Y;

%Return decomposition 3Y horz
GER.Stock.CG3Y=NaN(size(GER.Stock.Index));
GER.Stock.CG3Y=log(GER.Stock.Index./lag(GER.Stock.Index,36,NaN));
US.Stock.CG3Y=NaN(size(GER.Stock.Index));
US.Stock.CG3Y=log(US.Stock.Index./lag(US.Stock.Index,36,NaN));
UK.Stock.CG3Y=NaN(size(GER.Stock.Index));
UK.Stock.CG3Y=log(UK.Stock.Index./lag(UK.Stock.Index,36,NaN));
GER.Stock.DY3Y=NaN(size(GER.Stock.Index));
US.Stock.DY3Y=NaN(size(GER.Stock.Index));
UK.Stock.DY3Y=NaN(size(GER.Stock.Index));
for i=36:size(GER.Stock.Index);
GER.Stock.DY3Y(i,:) = sum(GER.Stock.DY(t(i)-35:t(i)));
US.Stock.DY3Y(i,:) = sum(US.Stock.DY(t(i)-35:t(i)));
UK.Stock.DY3Y(i,:) = sum(UK.Stock.DY(t(i)-35:t(i)));
end
US.Stock.ER3Y=NaN(size(GER.Stock.Index));
UK.Stock.ER3Y=NaN(size(GER.Stock.Index));
US.Stock.ER3Y=log(FX.EUvsUS./lag(FX.EUvsUS,36,NaN));
UK.Stock.ER3Y=log(FX.EUvsUK./lag(FX.EUvsUK,36,NaN));

%trends
VO = tsmovavg(GER.Stock.lp', 's', 48);
GER.Stock.lpTr=VO';
VO = tsmovavg(US.Stock.lp', 's', 48);
US.Stock.lpTr=VO';
VO = tsmovavg(UK.Stock.lp', 's', 48);
UK.Stock.lpTr=VO';

  










