    
    
    %--------------------------------------------------------------------------
    % SECTION 1: Simulated and Actual Time-Series
    %--------------------------------------------------------------------------
    % Defining the parameters
        
    alpha_1m=mean(GER.Stock.Ret(2:end));
    alpha_3y=mean(GER.Stock.Ret3Ya(38:end));
    beta_1m=var(GER.Stock.Ret(2:end));
    beta_3y=var(GER.Stock.Ret3Ya(38:end));
    alpha_LTB=mean(GER.LTBond.Yield(2:end));
    beta_LTB=var(GER.LTBond.Yield(2:end));
    % Simulate artificial series
    Num=size(GER.Stock.Ret,1);
    Wn_1m=alpha_1m+sqrt(beta_1m)*normrnd(0,1,Num,1);
    Wn_3y=alpha_3y+sqrt(beta_3y)*normrnd(0,1,Num,1);
    Wn_LTB=alpha_LTB+sqrt(beta_LTB)*normrnd(0,1,Num,1);
    % Plot the result
    s_start   = '31/01/1978';
s_end     = '31/12/2010';
date_find = datenum([s_start; s_end],'dd/mm/yyyy');
ss        = datefind(date_find(1,1),date);
se        = datefind(date_find(2,1),date);
T=ss-se+1;
%plot actual and simulated series 
run Figure001
   
 %-------------------------------------------------------------------------
    % Generate artificial AR series
    % Defining the parameters
    rho1=.99;
    rho2=0;
    rho3=0.8;
    % Simulate AR series
    GER.LTBond.Yieldsim1= NaN(size(GER.Stock.Index));
    GER.LTBond.Yieldsim1(2,1)=GER.LTBond.Yield(2,1);
    GER.LTBond.Yieldsim2= NaN(size(GER.Stock.Index));
    GER.LTBond.Yieldsim2(2,1)=GER.LTBond.Yield(2,1);
    GER.LTBond.Yieldsim3= NaN(size(GER.Stock.Index));
    GER.LTBond.Yieldsim3(2,1)=GER.LTBond.Yield(2,1);
    u=NaN(size(GER.Stock.Index));
    for i=3:Num
    u(i)= normrnd(0,1,1) ;  
    GER.LTBond.Yieldsim1(i,:)=rho1*GER.LTBond.Yieldsim1(i-1)+alpha_LTB*(1-rho1)+u(i)*sqrt((1-rho1^2)*beta_LTB);
    GER.LTBond.Yieldsim2(i,:)=rho2*GER.LTBond.Yieldsim2(i-1)+alpha_LTB*(1-rho2)+u(i)*sqrt((1-rho2^2)*beta_LTB);
    GER.LTBond.Yieldsim3(i,:)=rho3*GER.LTBond.Yieldsim3(i-1)+alpha_LTB*(1-rho3)+u(i)*sqrt((1-rho3^2)*beta_LTB);
    end
    GER.LTBond.Yieldsim= [GER.LTBond.Yieldsim1 GER.LTBond.Yieldsim2];
    %----------------------------------------------------------------------
    % plot actual and simulated 10 Tear YTM 
    run Figure002
 