%--------------------------------------------------------------------------
% SECTION 2: Persistence: A Monte Carlo Experiment
%--------------------------------------------------------------------------
    
    % Initializing the series:
reps=1000;
obs=200;
init=15;
x=NaN(obs,reps);
beta1=NaN(obs-init,reps);
%Defining Parameters
rho=0.9;
alpha=0;
vol=1;

% Initializing the series:
x(1,:)=alpha/(1-rho);
% Artificial series:
u1=vol.*normrnd(0,1,obs,reps);
for j=1:reps  
for i=2:obs
x(i,j)=rho*x(i-1,j)+alpha*(1-rho)+u1(i,j)*sqrt((1-rho^2)*vol); 
end
for k=init+1:obs
X=NaN(k-1,2);
X(:,1)=ones;
X(:,2)=x(1:k-1,j);
reg1=ols(x(2:k,j), X(1:k-1,:));
beta1(k-init,j)=reg1.beta(2);
end
end
dim=16:200;
av_beta1_hat(:,1)=mean(beta1,2);
%plot results of the experiment 
figure
plot(dim,av_beta1_hat',dim,(ones(size(dim)).*rho))
grid on
%xlim([dim(1) dim(end)])
xlabel('sample size')
ylabel('expected rho hat')
title('Bias of OLS estimator in an AR(1)')
 