
 %--------------------------------------------------------------------------
 % SECTION 3: Putting ARMA models at Work
 %--------------------------------------------------------------------------
 % Select the estimation sample
s_start   = '31/01/1979';
s_end     = '29/10/1993';
date_find = datenum([s_start; s_end],'dd/mm/yyyy');
first        = datefind(date_find(1,1),date);
last        = datefind(date_find(2,1),date);
T=first-last+1;


    % Estimate ARMA model 
    % ARMA(1,1) estimation
 
spec=garchset('VarianceModel','Constant','R',1,'M',1);
[coeff,errors,llf,innovation,sigma,summary]=garchfit(spec,GER.LTBond.Yield(first:last));
garchdisp(coeff,errors);
    %ARMA forecast
    horz=108;
    [SigmaForecast,MeanForecast] = garchpred(coeff,GER.LTBond.Yield(first:last),horz);
    Forecast_arma=MeanForecast;
    GER.LTBond.Yield_for_arma=NaN(size(GER.Stock.Ret));
    GER.LTBond.Yield_for_arma(1:last,1)=GER.LTBond.Yield(1:last,1);
    GER.LTBond.Yield_for_arma(last+1:(last+horz),1)=Forecast_arma(1:horz,1);
    % AR(1) estimation
    spec=garchset('VarianceModel','Constant','R',1);
    [coeff,errors,llf,innovation,sigma,summary]=garchfit(spec,GER.LTBond.Yield(first:last));
    garchdisp(coeff,errors);
    % AR forecast
    %spec_pred=garchset('VarianceModel','Constant','C',coeff.C,'R',1,'AR',coeff.AR,'K',coeff.K);
    [SigmaForecast,MeanForecast] = garchpred(coeff,GER.LTBond.Yield(first:last),horz);
    Forecast_ar=MeanForecast;
    GER.LTBond.Yield_for_ar=NaN(size(GER.Stock.Ret));
    GER.LTBond.Yield_for_ar(1:last,1)=GER.LTBond.Yield(1:last,1);
    GER.LTBond.Yield_for_ar(last+1:(last+horz),1)=Forecast_arma(1:horz,1);
    % Forecast unconditional mean
    Forecast_unc=ones(horz,1)*mean(GER.LTBond.Yield(first:last));
        GER.LTBond.Yield_for_unc=NaN(size(GER.Stock.Ret));
    GER.LTBond.Yield_for_unc(1:last,1)=GER.LTBond.Yield(1:last,1);
    GER.LTBond.Yield_for_unc(last+1:(last+horz),1)=Forecast_unc(1:horz,1);
    
    %plot actual and forecast 
    run Figure003    
    disp('***************************************************************')
    % % Recursive One-Step Ahead Forecasts
    disp('================================================================')
    disp('Recursive One-Step Ahead Forecasts')
    s_start   = '31/01/1979';
    s_end     = '29/10/1993';
    date_find = datenum([s_start; s_end],'dd/mm/yyyy');
    first        = datefind(date_find(1,1),date);
    last        = datefind(date_find(2,1),date);
    T=first-last+1;
    
    horz=1;
    forsmpl=40;
    LTBond_mean=NaN(size(GER.Stock.Ret));
    LTBond_upp=NaN(size(GER.Stock.Ret));
    LTBond_low=NaN(size(GER.Stock.Ret));
         
    for j=1:forsmpl
     %AR(1) estimation
     spec=garchset('VarianceModel','Constant','R',1);
    [coeff,errors,llf,innovation,sigma,summary]=garchfit(spec,GER.LTBond.Yield(first:last));
     garchdisp(coeff,errors);
          %AR(1) forecast
          spec_pred=garchset('VarianceModel','Constant','C',coeff.C,'R',1,'AR',coeff.AR,'K',coeff.K);
     [SigmaForecast,MeanForecast,SigmaTotal,MeanRMSE] = garchpred(spec_pred,GER.LTBond.Yield(first:last+j-1),horz);
     forecast_ar=MeanForecast;
     forecast_upp=MeanForecast+2*MeanRMSE;
     forecast_low=MeanForecast-2*MeanRMSE;
     LTBond_mean(last+j:last+j,1)=forecast_ar;
     LTBond_upp(last+j:last+j,1)=forecast_upp;
     LTBond_low(last+j:last+j,1)=forecast_low;
    end
     %plotting recursive forecast performance
     
    run Figure004
   
   %computing RMSE  
    RMSE=sqrt(sum((LTBond_mean(last+1:last+forsmpl)-GER.LTBond.Yield(last+1:last+forsmpl)).^2));
    var1=strcat('For_');
    assignin('base',var1,LTBond_mean);
    var2=strcat('UpperBound_');
    assignin('base',var2,LTBond_upp);
    var3=strcat('LowBound_');
    assignin('base',var3,LTBond_low);
    var4=strcat('RMSE_');
    assignin('base',var4,RMSE);
    clear var1 var2 var3 var4 
    